<?php
/* 
Plugin Name: Back and Forward Button
Plugin URI: https://store.devilhunter.net/wordpress-plugin/back-and-forward-button/
Description: Add ◄ and ► button anywhere in website matching theme color and style. Alternative of Previous and Next page. Go to Appearance > Widgets, and drag Back and Forward Button in sidebar or footer or into any widgetized area. Insert into page or post by Page Builder, or by Shortcode [backandforwardbutton_tawhidurrahmandear_widget]
Version: 2.0
Author: Tawhidur Rahman Dear
Author URI: https://www.tawhidurrahmandear.com
Requires at least: 5.5
Requires PHP: 7.4
License: GPLv2 or later
Text Domain: back-and-forward-button
 */


 // Prevent direct file access
if ( ! defined ( 'ABSPATH' ) ) {
	exit;
}
//

function backandforwardbutton_by_tawhidurrahmandear_links($plugin_meta, $plugin_file) {
    if ($plugin_file === plugin_basename(__FILE__)) {
        $new_links = array(
            '<a href="https://store.devilhunter.net/wordpress-plugin/back-and-forward-button" target="_blank">Introduction to Plugin with Documentation</a>',
            '<a href="https://wordpress.org/plugins/back-and-forward-button#reviews" target="_blank">Rate and Review at WordPress.org</a>',
            '<a href="https://itsolution.devilhunter.net" target="_blank">Hire for WordPress Web Development</a>',
        );

        // Add the new links to the existing array of links
        $plugin_meta = array_merge($plugin_meta, $new_links);
    }
    return $plugin_meta;
}
add_filter('plugin_row_meta', 'backandforwardbutton_by_tawhidurrahmandear_links', 10, 2);


// The Plugin
class DSbackandforwardbuttonByTawhidurRahmanDear extends WP_Widget {
    public function __construct() {
        $plugin_name = $this->get_plugin_name();
        parent::__construct(
            'backandforwardbutton_by_tawhidurrahmandear',
            $plugin_name,
            array('description' => sprintf(__('Drag Back and Forward Button in sidebar or footer or into any widgetized area', 'back-and-forward-button'), $plugin_name))
        );
    }
    private function get_plugin_name() {
        if (!function_exists('get_plugin_data')) {
            require_once(ABSPATH . 'wp-admin/includes/plugin.php');
        }
        $plugin_data = get_plugin_data(__FILE__);
        return isset($plugin_data['Name']) ? esc_html($plugin_data['Name']) : '';
    }

    // Outputs the widget form in the admin dashboard
    public function form($instance) {
        ?>
        <p>
            <?php esc_html_e('You can also use Shortcode [backandforwardbutton_tawhidurrahmandear_widget] or Page Builder', 'back-and-forward-button'); ?>
        </p>
        <?php
    }

    // Output adjustment for front-end
    public function widget($args, $instance) {
        $args['before_widget'] = '';
        $args['after_widget'] = '';
        // Custom HTML
        echo get_backandforwardbutton_widget_content();
    }
}

// Shared Content for both Widget and Shortcode
function backandforwardbuttontawhidurrahmandear_script() {
    ?>
<!-- Widget Code Begins -->
<center>
<form>
<input type="button" value="◄" onclick="history.back()">
<input type="button" value="►" onclick="history.forward()">
</form>
</center>
<!-- Widget Code Ends -->
    <?php
}

// Widget output
function get_backandforwardbutton_widget_content() {
    ob_start();
    ?>
    <center>
    <div class="backandforwardbuttontawhidurrahmandear">
        <?php backandforwardbuttontawhidurrahmandear_script(); ?>
    </div>
    <center>
    <?php
    return ob_get_clean();
}

// Register the widget
function register_backandforwardbutton_by_tawhidurrahmandear() {
    register_widget('DSbackandforwardbuttonByTawhidurRahmanDear');
}
add_action('widgets_init', 'register_backandforwardbutton_by_tawhidurrahmandear');

// Inline Shortcode function for inline usage
function backandforwardbuttontawhidurrahmandear_shortcode() {
    ob_start();
    backandforwardbuttontawhidurrahmandear_script(); 
    return ob_get_clean();
}

// Register the shortcode
add_shortcode('backandforwardbutton_tawhidurrahmandear_widget', 'backandforwardbuttontawhidurrahmandear_shortcode');